package com.ann.exceldemo.web.GsonAdapter;


import com.ann.exceldemo.web.common.TypeConvertUtils;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

import java.io.IOException;
import java.util.Date;

/**
 * @author taohongsheng
 * @date 2020/7/29
 * @description
 */
public class DateTimeTypeAdapter extends TypeAdapter<Date> {

    @Override
    public void write(JsonWriter out, Date value) throws IOException {
        if (value == null) {
            out.nullValue();
        } else {
            out.value(value.getTime());
        }
    }

    @Override
    public Date read(JsonReader in) throws IOException {
        try {
            return TypeConvertUtils.parseDate(in.nextString());
        } catch (Exception e) {
            throw new JsonParseException("Could not parse date", e);
        }
    }

}
