/*
 * Copyright (c) 2014 xiaomi.com. All Rights Reserved.
 */
package com.ann.exceldemo.web.common;

import com.ann.exceldemo.web.constant.CodeOfEnum;
import com.google.common.base.Preconditions;
import org.apache.commons.lang3.ArrayUtils;

/**
 * codeOf 类型的枚举工具类
 *
 * @author: dengliren Date: 2014-09-05 上午11:42
 * @version: \$Id$
 */
public class CodeOfEnumHelper {

    /**
     * 根据code查找合适的枚举值
     *
     * @param code
     * @param clazz
     * @param <T>
     * @return
     */
    public static <T extends CodeOfEnum> T codeOf(int code, Class<T> clazz) {
        Preconditions.checkNotNull(clazz, "枚举类名称不能为NULL");

        T[] enums = clazz.getEnumConstants();

        Preconditions.checkArgument(!ArrayUtils.isEmpty(enums), "枚举类必须包含枚举常量");

        for (T e : enums) {
            if (e.code() == code) {
                return e;
            }
        }

        throw new IllegalStateException("为找到合适枚举值");
    }

}
