/*
 * Copyright (c) 2014 xiaomi.com. All Rights Reserved.
 */
package com.ann.exceldemo.web.common;

import com.ann.exceldemo.web.constant.CodeOfEnum;
import com.ann.exceldemo.web.constant.KEY_BIZ;
import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.JsonToken;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.JsonDeserializer;

import java.io.IOException;

/**
 * CodeOf类型枚举JsonDeserializer
 *
 * @author: dengliren Date: 2014-09-06 下午6:13
 * @version: \$Id$
 */
public class CodeOfEnumJsonDeserializer extends JsonDeserializer<CodeOfEnum> {

    private Class<? extends CodeOfEnum> outClass;

    public CodeOfEnumJsonDeserializer(Class<? extends CodeOfEnum> clazz) {
        this.outClass = clazz;
    }

    @Override
    public CodeOfEnum deserialize(JsonParser jp, DeserializationContext ctxt) throws IOException, JsonProcessingException {

        JsonToken curr = jp.getCurrentToken();
        Integer code = null;

        if (curr == JsonToken.VALUE_NUMBER_INT) {
            code = Integer.valueOf(jp.getText());
        } else if (curr == JsonToken.VALUE_STRING || curr == JsonToken.FIELD_NAME) {
            code = jp.getIntValue();
        }

        if (code == null) {
            throw new MyException(KEY_BIZ.JSON_PARSE_FAIL);
        }

        return CodeOfEnumHelper.codeOf(code, outClass);
    }
}
