package com.ann.exceldemo.web.common;

import com.ann.exceldemo.web.constant.KEY_BIZ;

import java.util.regex.Matcher;

@SuppressWarnings("serial")
public class MyException extends RuntimeException {
    // --------------------------------------
    public MyException(KEY_BIZ KEY) {
        super();
        this.msg = KEY.getDesc();
        this.code = KEY.getValue();
        this.KEYBIZ = KEY;
    }

    public MyException(KEY_BIZ KEY, Object obj) {
        super();
        this.msg = KEY.getDesc().replaceAll("\\{v\\}", Matcher.quoteReplacement(obj + ""));
        this.code = KEY.getValue();
        this.KEYBIZ = KEY;
    }

    public MyException(KEY_BIZ key, Throwable e) {
        this(key, null, e);
    }

    public MyException(KEY_BIZ key, Object obj, Throwable e) {
        super(e);
        String desc = key.getDesc();
        if (obj != null) {
            desc = desc.replaceAll("\\{v\\}", Matcher.quoteReplacement(obj + ""));
        }
        this.msg = desc;
        this.code = key.getValue();
        this.KEYBIZ = key;
    }

    public MyException(String message, Exception e) {
        super(message, e);
    }

    // --------------------------------------
    public String getMsgCode() {
        return code;
    }

    public void setMsgCode(String msgCode) {
        this.code = msgCode;
    }

    public String getMsg() {
        return this.msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

    public KEY_BIZ getKEYBIZ() {
        return KEYBIZ;
    }

    public void setKEYBIZ(KEY_BIZ kEYBIZ) {
        KEYBIZ = kEYBIZ;
    }

    @Override
    public String getMessage() {
        String message = "{code:" + code + ", msg:" + msg + "}";
        if (StringUtil.isNotEmpty(super.getMessage())) {
            return message + super.getMessage();
        } else {
            return message;
        }
    }

    private String code;
    private String msg;
    private KEY_BIZ KEYBIZ;

}
