package com.ann.exceldemo.web.common;

import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.stereotype.Component;

import java.util.Map;

/**
 * 操作spring 的工具类
 */
@Component
public class SpringUtil implements ApplicationContextAware {

    private static ApplicationContext context = null;

    // private static Logger logger = Logger.getLogger(SpringUtil.class);
    @Override
    public void setApplicationContext(ApplicationContext ctx) throws BeansException {
        context = ctx;
    }

    public static ApplicationContext getApplicationContext() throws BeansException {
        return context;
    }

    /**
     * 获取Spring 容器中的bean
     *
     * @param bName : bean name
     * @return
     */
    @SuppressWarnings("unchecked")
    public static <T> T getBean(String bName) {
        if (bName == null || "".equals(bName.trim())) {
            return null;
        }
        return (T) context.getBean(bName);
    }

    /**
     * 获取Spring 容器中的bean
     *
     * @return
     */
    public static <T> T getBean(Class<T> c) {
        if (c == null) {
            return null;
        }
        return context.getBean(c);
    }

    /**
     * @param clazz
     * @return
     */
    public static <T> Map<String, T> getBeansOfType(Class<T> clazz) {
        return context.getBeansOfType(clazz);
    }
}
