package com.ann.exceldemo.web.constant;


/**
 * 日志消息记录的key值,全部要在此定义
 */
public enum KEY_BIZ {
    SUCCESS("200", "api success"),
    EXCEPTION("400", "api exception: {v}"),
    DISTRIBUTED_LOCK_FAIL("700", "分布式锁获取失败， info :{v}"),
    NEED_RETRY("800", "需重试! {v}"),
    CACHE_ERROR("801", "本地缓存异常！{v}"),
    INVALID_PASS("802", "无效参数{v} "),
    JSON_PARSE_FAIL("900", "json解析失败"),
    WITHOUT_ACTUAL_TYPE("901", "The parameterized type does not specify a specific type"),
    UN_KNOW("1000", "未知异常"),


    ;
    public final String value; // key值
    private final String desc; // key文字说明

    private KEY_BIZ(String value, String desc) {
        this.value = value;
        this.desc = desc;
    }

    public String getDesc() {
        return desc;
    }

    public String getValue() {
        return value;
    }

    public static KEY_BIZ getFromValue(String value) {
        for (KEY_BIZ key_biz : values()) {
            if (key_biz.getValue().equalsIgnoreCase(value)) {
                return key_biz;
            }
        }
        throw new IllegalArgumentException("error value for KEY_BIZ, param: " + value);
    }

    /**
     * 获取异常描述信息
     *
     * @param value
     * @return
     */
    public static String getDescForEnum(String value) {
        for (KEY_BIZ key_biz : values()) {
            if (key_biz.getValue().equalsIgnoreCase(value)) {
                return key_biz.getDesc();
            }
        }
        return null;
    }

    @Override
    public String toString() {
        return "{" +
                "value='" + value + '\'' +
                ", desc='" + desc + '\'' +
                '}';
    }
}
