package com.ann.exceldemo.web.dto;

import net.sf.json.JSONArray;
import net.sf.json.JSONObject;

/**
 * 存放一次http会话中必要参数,scope为request
 */
public class UserSession {

    public static Long getAdminUserId() {
        return ADMIN_USERID_THREAD_LOCAL.get();
    }

    public static Long getClientUserId() {
        return CLIENT_USERID_THREAD_LOCAL.get();
    }

    public static String getAdminUserName() {
        return ADMIN_USERNAME_THREAD_LOCAL.get();
    }

    public static JSONObject getRequestBody() {
        return REQUESTBODY_THREAD_LOCAL.get();
    }

    public static JSONObject getRequestHeader() {
        return REQUESTHEADER_THREAD_LOCAL.get();
    }

    public static String getFromIp() {
        return FROMIP_THREAD_LOCAL.get();
    }

    public static String getClientId() {
        return CLENTID_THREAD_LOCAL.get();
    }

    public static String getCountryName() {
        return COUNTRY_NAME.get();
    }

    // ----------------------------------------------------操作员
    private static final ThreadLocal<Long> ADMIN_USERID_THREAD_LOCAL = new ThreadLocal<Long>();
    private static final ThreadLocal<String> ADMIN_USERNAME_THREAD_LOCAL = new ThreadLocal<String>();
    // ----------------------------------------------------客户
    private static final ThreadLocal<Long> CLIENT_USERID_THREAD_LOCAL = new ThreadLocal<Long>();
    private static final ThreadLocal<String> FROMIP_THREAD_LOCAL = new ThreadLocal<String>();
    private static final ThreadLocal<JSONObject> REQUESTBODY_THREAD_LOCAL = new ThreadLocal<JSONObject>();
    private static final ThreadLocal<JSONObject> REQUESTHEADER_THREAD_LOCAL = new ThreadLocal<JSONObject>();
    private static final ThreadLocal<String> CLENTID_THREAD_LOCAL = new ThreadLocal<String>();
    private static final ThreadLocal<String> LANGUAGE_LOCAL = new ThreadLocal<String>();
    private static final ThreadLocal<String> COUNTRY_NAME = new ThreadLocal<String>();

    private static final ThreadLocal<JSONArray> REQUESTBODY_ARRY_THREAD_LOCAL = new ThreadLocal<JSONArray>();
    private static final ThreadLocal<JSONArray> REQUESTHEADER_ARRY_THREAD_LOCAL = new ThreadLocal<JSONArray>();

    public static void setUser(Long adminUserId, String userName) {
        ADMIN_USERID_THREAD_LOCAL.set(adminUserId);
        ADMIN_USERNAME_THREAD_LOCAL.set(userName);
    }

    public static void setFromIp(String remoteAddr) {
        FROMIP_THREAD_LOCAL.set(remoteAddr);
    }

    public static void setBody(JSONObject body) {
        REQUESTBODY_THREAD_LOCAL.set(body);
    }

    public static void setHeader(JSONObject header) {
        REQUESTHEADER_THREAD_LOCAL.set(header);
    }

    public static void setClientId(String clientId) {
        CLENTID_THREAD_LOCAL.set(clientId);
    }

    public static void setClientUserId(Long clentUserId) {
        CLIENT_USERID_THREAD_LOCAL.set(clentUserId);
    }

    public static void setLanguage(String lng) {

        LANGUAGE_LOCAL.set(lng);
    }

    public static void setCountryName(String countryName) {

        COUNTRY_NAME.set(countryName);
    }

    public static JSONArray getRequestBodyArry() {
        return REQUESTBODY_ARRY_THREAD_LOCAL.get();
    }

    public static void setBodyArr(JSONArray body) {
        REQUESTBODY_ARRY_THREAD_LOCAL.set(body);
    }

    public static void setHeaderArr(JSONArray header) {
        REQUESTHEADER_ARRY_THREAD_LOCAL.set(header);
    }

    public static void clear() {
        ADMIN_USERNAME_THREAD_LOCAL.remove();
        ADMIN_USERID_THREAD_LOCAL.remove();
        FROMIP_THREAD_LOCAL.remove();
        REQUESTBODY_THREAD_LOCAL.remove();
        LANGUAGE_LOCAL.remove();
        COUNTRY_NAME.remove();
        CLIENT_USERID_THREAD_LOCAL.remove();
        REQUESTBODY_ARRY_THREAD_LOCAL.remove();
    }

}
