package com.ann.exceldemo.web.impl;

import com.ann.exceldemo.web.dto.TaskConfig;
import com.ann.exceldemo.web.mapper.TaskConfigMapper;
import com.ann.exceldemo.web.service.TaskConfigService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

@Slf4j
@Service
public class TaskConfigServiceImpl implements TaskConfigService {
    @Resource
    private TaskConfigMapper taskConfigMapper;

    @Override
    public List<TaskConfig> queryAll() {
        return taskConfigMapper.queryAll();
    }

    @Override
    public Integer update(TaskConfig taskConfig) {
        if (null == taskConfig || null == taskConfig.getId()) {
            return 0;
        }
        taskConfig.setUpdateTime(new Date());
        return taskConfigMapper.update(taskConfig);
    }

    @Override
    public int insert(TaskConfig taskConfig) {
        if (null == taskConfig) {
            return 0;
        }
        return taskConfigMapper.insert(taskConfig);
    }

    @Override
    public TaskConfig queryById(Integer id) {
        return taskConfigMapper.queryById(id);
    }

    @Override
    public Integer updateById(Integer id, Integer taskStatus, String operator) {
        return taskConfigMapper.updateById(id, taskStatus, operator);
    }

    @Override
    public Integer updateContext(Integer id, String context, String operator) {
        return taskConfigMapper.updateContext(id, context, operator);
    }

    @Override
    public Integer updateSaveType(Integer id, String type, String operator) {
        return taskConfigMapper.updateSaveType(id, type, operator);

    }
}
