package com.ann.exceldemo.web.job;

import org.quartz.*;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * 任务类
 */
public class HelloJobListener implements Job {
    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        //获取Trigger
        Trigger trigger = jobExecutionContext.getTrigger();
        //获取JobDetail
        JobDetail jobDetail = jobExecutionContext.getJobDetail();
        //获取Scheduler
        Scheduler scheduler = jobExecutionContext.getScheduler();
        //获取Trigger名字
        trigger.getKey().getName();
        //获取Trigger组名（默认为 DEFAULT）
        trigger.getKey().getGroup();
        //触发器触发的预定时间。
        jobExecutionContext.getScheduledFireTime();
        //实际触发时间。例如，计划时间可能是 10:00:00，但如果调度程序太忙，实际触发时间可能是 10:00:03。
        jobExecutionContext.getFireTime();
        //上次触发时间
        jobExecutionContext.getPreviousFireTime();
        //下次触发时间
        jobExecutionContext.getNextFireTime();

        System.out.println(jobExecutionContext.getTrigger().getJobDataMap().get("message")); //TriggerMessage
        System.out.println(jobExecutionContext.getJobDetail().getJobDataMap().get("message")); //JobDetailMessage

        System.out.println(jobExecutionContext.getMergedJobDataMap().get("message")); //TriggerMessage

        // 输出当前时间
        Date date = new Date();
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String dateString = dateFormat.format(date);

        System.out.println("have a nice day" + dateString);
    }
}
