package com.ann.exceldemo.web.mapper;

import com.ann.exceldemo.web.dto.TaskConfig;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface TaskConfigMapper {

    /**
     * 查询所有数据
     *
     * @return
     */
    List<TaskConfig> queryAll();

    /**
     * 更新
     *
     * @param taskConfig
     */
    int update(TaskConfig taskConfig);

    /**
     * 更新
     *
     * @param taskConfig
     */
    int insert(TaskConfig taskConfig);

    /**
     * @param id
     * @return
     */
    TaskConfig queryById(@Param("id") Integer id);

    /**
     * 根据ID更新任务配置状态
     *
     * @param id
     * @param taskStatus
     * @param operator
     * @return
     */
    Integer updateById(@Param("id") Integer id, @Param("taskStatus") Integer taskStatus, @Param("operator") String operator);

    /**
     * 更新模版信息
     * @param id
     * @param context
     * @param operator
     * @return
     */
    Integer updateContext(@Param("id") Integer id, @Param("context") String context, @Param("operator") String operator);

    /**
     * 更新保存类型
     * @param id
     * @param type
     * @param operator
     */
    Integer updateSaveType(@Param("id")Integer id,@Param("type") String type,@Param("operator") String operator);
}
