package com.ann.exceldemo;

import com.ann.exceldemo.web.common.WeChatBotUtils;
import com.ann.exceldemo.web.dto.TaskConfig;
import com.ann.exceldemo.web.schedule.HelloScheduleDemo;
import com.ann.exceldemo.web.service.TaskConfigService;
import com.grapecity.documents.excel.*;
import org.apache.pdfbox.contentstream.operator.state.Save;
import org.junit.jupiter.api.Test;
import org.junit.runner.RunWith;
import org.quartz.SchedulerException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.format.FormatterRegistrar;
import org.springframework.test.context.junit4.SpringRunner;

import javax.annotation.Resource;
import java.io.BufferedReader;
import java.io.FileReader;
import java.time.format.DateTimeFormatter;
import java.util.Date;
import java.util.GregorianCalendar;

@RunWith(SpringRunner.class)
@SpringBootTest(classes = {ExcelDemoApplication.class})
class ExcelDemoApplicationTest {
    @Autowired
    private TaskConfigService taskConfigService;
    @Resource
    private HelloScheduleDemo helloScheduleDemo;

    private static final String BOT_URL = "https://qyapi.weixin.qq.com/cgi-bin/webhook/send?key=980f1397-376b-4ef9-a2dc-beb03bb401e7";

    @Test
    void test1() {
        TaskConfig taskConfig = new TaskConfig();
        taskConfig.setOperator("ann");
        taskConfig.setCreateTime(new Date());
        taskConfig.setUpdateTime(new Date());
        taskConfig.setTaskContext("{}");
        taskConfig.setTaskId("test");
        taskConfig.setTaskName("测试数据");
        taskConfig.setTaskType("订单1");
        taskConfig.setTaskStatus(0);

        GregorianCalendar calendar = new GregorianCalendar();
        int res = taskConfigService.insert(taskConfig);
        System.out.println(res);
    }

    /**
     * 测试定时任务
     */
    @Test
    void testSchedule() throws SchedulerException {
        helloScheduleDemo.execute();
    }

    /**
     * 测试定时任务
     */
    @Test
    void webChatSendTest() throws Exception {
        WeChatBotUtils chatBotUtils = new WeChatBotUtils(BOT_URL, false);
//        chatBotUtils.sendImgMsg("pig.png");
        chatBotUtils.sendFileMsg("/Users/yak/myProject/exceldemo/src/main/resources/static/order/test.xlsx");
        helloScheduleDemo.execute();
    }

    @Test
    void tt() throws Exception {
        //创建工作薄
        Workbook workbook = new Workbook();
        //获取一个sheet
        IWorksheet worksheet = workbook.getWorksheets().get(0);
        worksheet.getRange("B6").setFormula("=IMABS(IMPOWER(\"1+i\",3))");
        Object res = worksheet.getRange("B6").getValue();

        System.out.println(res);
    }

}
